/* Ce programme doit etre compil en statique
 *  l'aide de diet gcc.
 * Il permet de surveiller une liste de fichiers
 * pre-tablie et signale toute modification en
 * vrifiant les md5sum. Il est conseill d'utiliser
 * ce programme sur floppy en lecture seule ou sur
 * CDROM.
 * 
 * Franois Boisson, Maisons-Alfort
 * Le 31 Dcembre 2004
 * 
 */
#include "surv.h"

char *liste_fichiers="/etc/liste_surveillance";
char *signatures="/var/spool/.surveillance";
int verbeux = 0;

void ausecours()
{
  printf("surveillance [-f liste_fichiers] [-s fichier_signatures] [-i][-v]\n");
  printf("\n\tCheck all md5sums of files in \"liste_fichiers\" with the md5sums\n");
  printf("\tin the file \"fichier_signatures\".\n");
  printf("\tThis file is build if call with \"-i\" flag. Verbose if \"-v\".\n");
  printf("\n\t Dcembre 2004 (Franois Boisson)\n");

  exit(2);
}




main(argc,argv)
int argc;
char **argv;
{
  int option,i;
  int verifie=1;
  FILE *sgns;
  FILE *fichiers;
  unsigned char nom[1024];
  unsigned char md5c[16];
  unsigned char *md5f;
  int compte =0;

  while ((option = getopt(argc,argv,"f:s:ivh")) != -1) {
    switch(option) {
    case 'f':
      liste_fichiers = optarg;
      break;
    case 's':
      signatures = optarg;
      break;
    case 'i':
      verifie=0;
      break;
   case 'v':
      verbeux = 1;
      break;
    case 'h':
    case '?':
    default:
      ausecours(); 
      break;
    }
  }
  if ((fichiers=fopen(liste_fichiers,"r")) == NULL)
    {
      printf("Erreur ouverture %s\n",liste_fichiers);
      exit(1);
    }
  if (verifie == 0) {
    /* ecriture du fichier de vrification */
    if ((sgns=fopen(signatures,"r")) != NULL)
      {
	printf("Please delete %s first!\n",signatures);
	fclose(sgns);
	exit(1);
      }
    if ((sgns=fopen(signatures,"w+")) == NULL)
      {
	printf("Erreur ouverture %s\n",signatures);
	exit(1);
      }
    while(fgets(nom,1024,fichiers)!=NULL)
      {
	for(i=0;((i<1024)&&(nom[i]!='\n')&&(nom[i]!=0));i++);
	nom[i]=0;
	if((md5f=filemd5(nom)) == NULL)
	  {
	  printf("Erreur %s inexistant\n",nom);
	  fclose(sgns);fclose(fichiers);exit(1);
	  }
	if (verbeux)
	  {
	    printf("%s: ",nom);
	    for(i=0;i<16;printf("%02x",md5f[i++]));
	    printf("\n");
	  }
	fwrite(md5f,sizeof(char),16,sgns);
      }
    fclose(sgns);
    fclose(fichiers);
    exit(0);
  }
  /* vrification */

    if ((sgns=fopen(signatures,"r")) == NULL)
      {
	printf("File %s is absent!\n",signatures);
	exit(1);
      }
    while(fgets(nom,1024,fichiers)!=NULL)
      {
	for(i=0;(i<1024)&&(nom[i]!='\n')&&(nom[i]!=0);i++);
	nom[i]=0;
	/*	printf("%d\n",fread(md5c,sizeof(char),16,sgns));*/
	fread(md5c,sizeof(char),16,sgns);
	if((md5f=filemd5(nom)) == NULL)
	  {
	  printf("Erreur:: %s absent\n",nom);
	  fclose(sgns);fclose(fichiers);exit(1);
	  }
	if (verbeux)
	  {
	    printf("%s:\n\t",nom);
	    for(i=0;i<16;printf("%02x",md5f[i++]));
	    printf("\n\t");
	    for(i=0;i<16;printf("%02x",md5c[i++]));
	    printf("\n");
	  }
	for(i=0;(i<16) && (md5c[i] == md5f[i]);i++)
	  /*	  printf("%02x=%02x\n",md5c[i],md5f[i]);*/;
	if (i!=16) 
	  {
	    printf("Erreur:: %s modified\n",nom);
	    compte++;
	  }

      }
    fclose(sgns);
    fclose(fichiers);
    if (compte == 0) exit(0);
    printf("%d modified files\n",compte);
    exit(1);
}





